<template>
  <q-layout>
    <q-page-container>
      <q-page class="bg-grey-3">
        <div class="container">
          <div class="text-h5 text-center text-bold q-mb-md q-pt-lg">
            <router-link to="/login">
              <q-avatar square size="60px">
                <img src="~/assets/logo.png" />
              </q-avatar>
            </router-link>
            <div class="q-mt-sm">Đăng Ký Thành Viên</div>
          </div>
          <q-form @submit.prevent="onSubmit">
            <q-card>
              <q-card-section>
                <div class="row q-col-gutter-md q-mb-md">
                  <div class="col-12 col-md-6">
                    <q-input v-model="registerForm.fullName" outlined label="Họ tên *" />
                  </div>
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.phoneNumber"
                      outlined
                      type="tel"
                      label="Số điện thoại *"
                      mask="(###) ### - ####"
                      unmasked-value
                    />
                  </div>
                </div>
                <div class="row q-col-gutter-md q-mb-md">
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.password"
                      type="password"
                      outlined
                      label="Mật khẩu *"
                    />
                  </div>
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.confirmPassword"
                      type="password"
                      outlined
                      label="Nhập lại mật khẩu *"
                    />
                  </div>
                </div>
                <div class="row q-col-gutter-md q-mb-md">
                  <div class="col-12 col-md-6">
                    <q-input
                      v-if="infoType === 'nationalId'"
                      v-model="registerForm.nationalId"
                      outlined
                      label="CMND *"
                      mask="### ### ###"
                      unmasked-value
                    />
                    <q-input
                      v-else-if="infoType === 'nationalIdNew'"
                      v-model="registerForm.nationalId"
                      outlined
                      label="Căn cước *"
                      mask="#### #### ####"
                      unmasked-value
                    />
                    <q-input
                      v-else
                      v-model="registerForm.otherInformation"
                      outlined
                      label="Thông tin khác"
                    />
                  </div>
                  <div class="col-12 col-md-6">
                    <q-select
                      outlined
                      v-model="registerForm.gender"
                      :options="genderOptions"
                      label="Giới tính *"
                    />
                  </div>
                </div>
                <div class="q-gutter-sm q-mb-md">
                  <q-radio v-model="infoType" val="nationalId" label="CMND" />
                  <q-radio v-model="infoType" val="nationalIdNew" label="Căn cước" />
                  <!-- <q-radio v-model="infoType" val="other" label="Thông tin khác" /> -->
                </div>
                <city-component v-model="registerForm.fullAddress" class="q-mb-md" />
                <div class="row q-col-gutter-md q-mb-md">
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.email"
                      type="email"
                      outlined
                      label="Email *"
                      class="q-mb-md"
                    />
                  </div>
                  <div class="col-12 col-md-6">
                    <q-input v-model="registerForm.referral" outlined label="Mã giới thiệu" />
                  </div>
                </div>

                <div class="q-gutter-sm q-mb-md">
                  <q-radio v-model="registerForm.userRetail" val="CONTRIBUTOR" label="Thành Viên" />
                  <q-radio v-model="registerForm.userRetail" val="SALE" label="Điểm Bán Hàng" />
                  <q-radio v-model="registerForm.userRetail" val="DELIVERY" label="Điểm Giao Hàng" />
                </div>
                <div class="row q-col-gutter-md q-mb-md">
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.companyAddress"
                      outlined
                      label="Địa chỉ công ty (nếu có)"
                    />
                  </div>
                  <div class="col-12 col-md-6">
                    <q-input
                      v-model="registerForm.companyPhone"
                      outlined
                      label="Điện thoại công ty (nếu có)"
                      mask="(###) ### - ####"
                      unmasked-value
                    />
                  </div>
                </div>
                <image-uploader
                  v-model="registerForm.medias"
                  class="q-mb-md"
                  label="Hình chụp CMND, CCCD hoặc Hộ chiếu (chụp 2 mặt)"
                  :max="2"
                />
                <policy v-model="registerForm.isAccept" />

                <div class="q-mt-md">
                  <q-btn no-caps label="Đăng Ký" type="submit" color="primary" />
                  <q-btn
                    no-caps
                    label="Nhập Lại"
                    type="reset"
                    color="primary"
                    flat
                    class="q-ml-sm"
                  />
                </div>
              </q-card-section>
            </q-card>
          </q-form>
          <register-payment-info v-model="registerPaymentPopup" :user-id="registerUserId" />
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapActions } from 'vuex';
import { GENDER } from '~/commons/enums';
import ImageUploader from '~/components/commons/ImageUploader.vue';
import RegisterPaymentInfo from '~/components/user/RegisterPaymentInfo.vue';
import Policy from '~/components/Policy.vue';
import CityComponent from '~/components/commons/City.vue';

export default {
  components: { ImageUploader, Policy, CityComponent, RegisterPaymentInfo },
  data() {
    return {
      registerPaymentPopup: false,
      registerUserId: '',
      openPolicyForm: false,
      infoType: 'nationalId',
      registerForm: {
        email: '',
        password: '',
        confirmPassword: '',
        fullName: '',
        phoneNumber: '',
        gender: { label: 'Nam', value: GENDER.MALE },
        nationalId: '',
        passport: '',
        otherInformation: '',
        fullAddress: {
          city: '',
          district: '',
          ward: '',
          address: ''
        },
        companyAddress: '',
        companyPhone: '',
        medias: [],
        userRetail: 'CONTRIBUTOR',
        referral: null,
        isAccept: false
      },
      genderOptions: [
        { label: 'Nam', value: GENDER.MALE },
        { label: 'Nữ', value: GENDER.FEMALE }
      ]
    };
  },
  watch: {
    infoType: {
      handler() {
        this.registerForm.nationalId = '';
        this.registerForm.passport = '';
        this.registerForm.otherInformation = '';
      },
      immediate: true
    }
  },
  methods: {
    ...mapActions({
      register: 'auth/register'
    }),
    async onSubmit() {
      const { fullAddress, ...data } = this.registerForm;
      const form = { ...fullAddress, ...data };
      const result = await this.register(form);
      if (result) {
        this.registerPaymentPopup = true;
        this.registerUserId = result;
      }
    },
    onReset() {
      this.registerForm = {};
    }
  }
};
</script>

<style lang="scss" scoped>
.register-card {
  width: 50%;
  min-width: 450px;
}
</style>
